Ffidl_DLL_FILE = ffidl05.dll
Ffidl_TEST_FILE = ffidl_test05.dll
Swig_TEST_FILE = mathswig.dll

# fix these paths
TCL_DIR = f:/tcl
TCL_LD_LIB = $(TCL_DIR)/lib/libtclstub82.a
TCLSH_PROG = $(TCL_DIR)/bin/tclsh82
TCL_INC_DIR = $(TCL_DIR)/include

LIBFFI = libffi-2.00-beta
LIBFFI_LD_LIBS = $(LIBFFI)/.libs/libffi.a 
FFCALL = ffcall-1.6
FFCALL_LD_LIBS = $(FFCALL)/avcall/libavcall.a $(FFCALL)/callback/libcallback.a

# for libffi:
# #define USE_LIBFFI in ffidl.h
# #undef  USE_FFCALL in ffidl.h
# and uncomment these lines
SUBDIR = $(LIBFFI)
SUB_LD_LIBS = $(LIBFFI_LD_LIBS)
SUBINCLUDES = -I"$(LIBFFI)/include"
SUBMAKEFILE = Makefile

# for ffcall:
# #define USE_FFCALL in ffidl.h
# #undef  USE_LIBFFI in ffidl.h
# and uncomment these lines
#SUBDIR = $(FFCALL)
#SUB_LD_LIBS = $(FFCALL_LD_LIBS)
#SUBINCLUDES = -I$(FFCALL)/avcall -I$(FFCALL)/callback
#SUBMAKEFILE = Makefile.mingw32

CC = gcc
AS = as
LD = ld
DLLTOOL = dlltool
DLLWRAP = dllwrap 
WINDRES = windres

DLL_LDFLAGS = -mwindows -Wl,-e,_DllMain@12

baselibs   = -lkernel32 $(optlibs) -ladvapi32
winlibs    = $(baselibs) -luser32 -lgdi32 -lcomdlg32 -lwinspool
guilibs	   = $(libc) $(winlibs)

guilibsdll = $(libcdll) $(winlibs)

CFLAGS =-mno-cygwin 
INCLUDES = -I. -I$(TCL_INC_DIR) $(SUBINCLUDES)
DEFINES = 

CC_SWITCHES = $(CFLAGS) $(DEFINES) $(INCLUDES)

#		fundamentals of this library
SOURCES	=	ffidl.c
OBJECTS	=	ffidl.o

#-------------------------------------------------------#

default: $(Ffidl_DLL_FILE)

all:	default

test: $(Ffidl_DLL_FILE) $(Ffidl_TEST_FILE)
	-cd demos; $(TCLSH_PROG) test-ffidl.tcl
	-cd demos; $(TCLSH_PROG) test-libm.tcl
	-cd demos; $(TCLSH_PROG) test-gdbm-1.tcl
	-cd demos; $(TCLSH_PROG) test-gdbm-2.tcl
	-cd demos; $(TCLSH_PROG) test-gmpz.tcl
	-cd demos; $(TCLSH_PROG) test-gmpq.tcl
	-cd demos; $(TCLSH_PROG) test-callbacks.tcl
	-cd demos; $(TCLSH_PROG) test-qsort.tcl
	-cd demos; $(TCLSH_PROG) time-libm.tcl
	
clean:
	rm -f *.o *.def *~
	cd $(SUBDIR) && make -f $(SUBMAKEFILE) clean

distclean: clean
	rm -f *.dll
	cd $(SUBDIR) && make -f $(SUBMAKEFILE) distclean

#-------------------------------------------------------#

.c.o:
	$(CC) -c $(CC_SWITCHES) $< -o $@

#-------------------------------------------------------#

$(Ffidl_DLL_FILE): $(SUB_LD_LIBS) $(OBJECTS) dllentry.o ffidl.def
	$(DLLWRAP) -s $(DLL_LDFLAGS) -mno-cygwin -o $@ $(OBJECTS) \
		dllentry.o --def ffidl.def \
		$(SUB_LD_LIBS) $(TCL_LD_LIB)

ffidl.def: $(OBJECTS)
	$(DLLTOOL) --export-all --output-def $@ $(OBJECTS)

$(Ffidl_TEST_FILE): ffidl_test.o dllentry.o ffidl_test.def
	$(DLLWRAP) -s $(DLL_LDFLAGS) -mno-cygwin -o $@ ffidl_test.o \
		dllentry.o --def ffidl_test.def \
		$(TCL_LD_LIB)

ffidl_test.def: ffidl_test.o
	$(DLLTOOL) --export-all --output-def $@ ffidl_test.o

$(Swig_TEST_FILE): mathswig.o mathswig.def
	$(DLLWRAP) -s $(DLL_LDFLAGS) -mno-cygwin -o $@ mathswig.o \
		--def mathswig.def \
		$(DLL_LDLIBS) -lm -lc

mathswig.def: mathswig.o
	$(DLLTOOL) --export-all --output-def $@ mathswig.o

dllentry.o: dllentry.c
ffidl.o: ffidl.c
ffidl_test.o: ffidl_test.c


$(SUB_LD_LIBS): $(SUBDIR)/$(SUBMAKEFILE)
	cd $(SUBDIR) && make -f $(SUBMAKEFILE)

$(LIBFFI)/Makefile:
	cd $(SUBDIR) && CC="gcc -mno-cygwin" ./configure

