#
# rec.m4 --
#
#	This file provides a set of autoconf macros
#	for ffidl'ing around.
#

#
# RC_C_LONG_LONG - test for implementation of 'long long'
# taken from ffcall-1.6/autoconf/aclocal.m4/CL_LONGLONG
# renamed for consistency with AC_C_LONG_DOUBLE
#
AC_DEFUN(RC_C_LONG_LONG,
[AC_CACHE_CHECK(for long long type, rc_cv_c_long_long, [
AC_TRY_RUN([int main()
{
/* long longs don't work right with gcc-2.7.2 on m68k */
/* long longs don't work right with gcc-2.7.2 on rs6000: avcall/tests.c gets
   miscompiled. */
#ifdef __GNUC__
#if defined(__m68k__) || (defined(_IBMR2) || defined(__powerpc))
#if (__GNUC__ == 2)
#if (__GNUC_MINOR__ <= 7)
  exit(1);
#endif
#endif
#endif
#endif
  { long x = 944938507; long y = 737962842; long z = 162359677;
    exit(!(((long long) x)*((long long) y)>>32 == z));
  }
}],
rc_cv_c_long_long=yes, rc_cv_c_long_long=no,
dnl When cross-compiling, don't assume anything.
rc_cv_c_long_long="guessing no")
])
case "$rc_cv_c_long_long" in
  *yes) AC_DEFINE(HAVE_LONG_LONG) ;;
  *no) ;;
esac
])dnl

#
# RC_CHECK_ALIGNOF_ELT(TYPE [, CROSS-ALIGN])
#   - check alignment of type in a structure
#
AC_DEFUN(RC_CHECK_ALIGNOF_ELT,
[changequote(<<, >>)dnl
dnl The name to #define.
define(<<AC_TYPE_NAME>>, translit(alignof_elt_$1, [a-z *], [A-Z_P]))dnl
dnl The cache variable name.
define(<<AC_CV_NAME>>, translit(rc_cv_alignof_elt_$1, [ *], [_p]))dnl
changequote([, ])dnl
AC_MSG_CHECKING(alignof of element $1)
AC_CACHE_VAL(AC_CV_NAME,
[AC_TRY_RUN([#include <stdio.h>
main()
{
  struct { char e1; $1 e2; } t;
  FILE *f=fopen("conftestval", "w");
  if (!f) exit(1);
  fprintf(f, "%d\n", ((int)&t.e2)-((int)&t.e1));
  exit(0);
}], AC_CV_NAME=`cat conftestval`, AC_CV_NAME=0, ifelse([$2], , , AC_CV_NAME=$2))])dnl
AC_MSG_RESULT($AC_CV_NAME)
AC_DEFINE_UNQUOTED(AC_TYPE_NAME, $AC_CV_NAME)
undefine([AC_TYPE_NAME])dnl
undefine([AC_CV_NAME])dnl
])


#------------------------------------------------------------------------
# RC_CHECK_ARG_ALIGNOF(TYPE [, CROSS-ALIGN])
#	- find the argument alignment for TYPE
#	- not so easy it seems
#------------------------------------------------------------------------
AC_DEFUN(RC_CHECK_ARG_ALIGNOF, [
])

