/* -----------------------------------------------------------------------
   sysv.S - Copyright (c) 1996, 1998  Cygnus Solutions
   
   X86 Foreign Function Interface 

   $Id: sysv.S,v 1.2 1999/08/04 18:00:05 green Exp $

   Permission is hereby granted, free of charge, to any person obtaining
   a copy of this software and associated documentation files (the
   ``Software''), to deal in the Software without restriction, including
   without limitation the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the Software, and to
   permit persons to whom the Software is furnished to do so, subject to
   the following conditions:

   The above copyright notice and this permission notice shall be included
   in all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED ``AS IS'', WITHOUT WARRANTY OF ANY KIND, EXPRESS
   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL CYGNUS SOLUTIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR
   OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
   OTHER DEALINGS IN THE SOFTWARE.
   ----------------------------------------------------------------------- */

#define LIBFFI_ASM	
#include <ffi.h>

#if ! defined WIN86

#define prolog(func) .balign 16; .globl func; .type func,@function; func:

#define epilog(func) .##func##_end: .size    func,.##func##_end-func

#define extern(func) func

#else

#define prolog(func) .align 4; .global _##func;	.def _##func;  .scl 2;	.type 32;	.endef; _##func:

#define epilog(func)

#define extern(func) _##func

#endif
.text

/*
 * This routine performs the work of a foreign function call:
 *  1) allocating stack for the arguments
 *  2) calling to have the arguments copied to the stack
 *  3) calling the foreign function
 *  4) storing the return value
 */
	prolog(ffi_call_SYSV)

        pushl %ebp
        movl  %esp,%ebp

	# Make room for all of the new args.
	movl  16(%ebp),%ecx
	subl  %ecx,%esp

	movl  %esp,%eax

	# Place all of the ffi_prep_args in position
	pushl 12(%ebp)
	pushl %eax
	call  *8(%ebp)

	# Return stack to previous state and call the function
	addl  $8,%esp	

	call  *28(%ebp)

	# Remove the space we pushed for the args
	movl  16(%ebp),%ecx
	addl  %ecx,%esp
	
retbegin:	
	# Load %ecx with the return type code 
	movl  20(%ebp),%ecx	

retint:
	cmpl  $FFI_TYPE_INT,%ecx
	jne   retfloat
	# Load %ecx with the pointer to storage for the return value
	movl  24(%ebp),%ecx	
	movl  %eax,0(%ecx)
	jmp   epilogue

retfloat:
	cmpl  $FFI_TYPE_FLOAT,%ecx
	jne   retdouble
	# Load %ecx with the pointer to storage for the return value
	movl  24(%ebp),%ecx	
	fstps (%ecx)
	jmp   epilogue

retdouble:
	cmpl  $FFI_TYPE_DOUBLE,%ecx
	jne   retlongdouble
	# Load %ecx with the pointer to storage for the return value
	movl  24(%ebp),%ecx	
	fstpl (%ecx)
	jmp   epilogue

retlongdouble:
	cmpl  $FFI_TYPE_LONGDOUBLE,%ecx
	jne   retint64
	# Load %ecx with the pointer to storage for the return value
	movl  24(%ebp),%ecx	
	fstpt (%ecx)
	jmp   epilogue
	
retint64:	
	cmpl  $FFI_TYPE_SINT64,%ecx
        jne   retstruct
	# Load %ecx with the pointer to storage for the return value
	movl  24(%ebp),%ecx	
	movl  %eax,0(%ecx)
	movl  %edx,4(%ecx)
	
retstruct:
	# Nothing to do!

noretval:
epilogue:
        movl %ebp,%esp
        popl %ebp
        ret
	epilog(ffi_call_SYSV)
	
/*
 * This routine performs a foreign function call in the
 * Windows stdcall style, where the callee clears the stack
 */
#if defined WIN86
	prolog(ffi_call_STDCALL)

        pushl %ebp
        movl  %esp,%ebp

	# Make room for all of the new args.
	movl  16(%ebp),%ecx
	subl  %ecx,%esp

	movl  %esp,%eax

	# Place all of the ffi_prep_args in position
	pushl 12(%ebp)
	pushl %eax
	call  *8(%ebp)

	# Return stack to previous state and call the function
	addl  $8,%esp	

	call  *28(%ebp)

	# The space we pushed for the args
	# is already gone.
	jmp	retbegin		
#endif			

/*
 * These two functions perform the closure linkage.
 */
	prolog(ffi_closure_SYSV)

	pushl %ebp
	movl %esp,%ebp
	subl $16,%esp
	pushl %edi
	pushl %esi
	pushl %ebx
	movl %ecx,%esi
	leal -12(%ebp),%ecx
	movl %ecx,-16(%ebp)
	movl 12(%esi),%ebx
	movl 4(%ebx),%ecx
	leal 0(,%ecx,4),%eax
	subl %eax,%esp
	movl %esp,%edi
	leal 8(%ebp),%edx
	pushl %ebx
	pushl %edi
	leal -16(%ebp),%eax
	pushl %eax
	pushl %edx
	call extern(ffi_prep_incoming_args_SYSV)
	pushl 20(%esi)
	pushl %edi
	pushl -16(%ebp)
	pushl %ebx
	movl 16(%esi),%eax
	call *%eax
	movw 20(%ebx),%ax
	movl -16(%ebp),%ecx
	cmpw $FFI_TYPE_INT,%ax
	jne .L197
	movl (%ecx),%eax
	jmp .L198
	.p2align 4,,7
.L197:
	cmpw $FFI_TYPE_FLOAT,%ax
	jne .L199
	flds (%ecx)
	jmp .L198
	.p2align 4,,7
.L199:
	cmpw $FFI_TYPE_DOUBLE,%ax
	jne .L201
	fldl (%ecx)
	jmp .L198
	.p2align 4,,7
.L201:
	cmpw $FFI_TYPE_LONGDOUBLE,%ax
	jne .L203
	fldt (%ecx)
	jmp .L198
	.p2align 4,,7
.L203:
	cmpw $FFI_TYPE_SINT64,%ax
	jne .L198
	movl 0(%ecx),%eax;movl 4(%ecx),%edx
.L198:
#if defined WIN86
	# deal with stdcall/cdecl, address of our ret
	# NB, 24 is offsetof(ffi_closure, ret)
	leal 24(%esi),%ecx
#endif	
	leal -28(%ebp),%esp
	popl %ebx
	popl %esi
	popl %edi
	leave
#if defined WIN86
	# deal with stdcall/cdecl, jump to the ret
	pushl %ecx
#endif	
	ret
	epilog(ffi_closure_SYSV)

	prolog(ffi_closure_raw_SYSV)

	pushl %ebp
	movl %esp,%ebp
	subl $12,%esp
	pushl %esi
	pushl %ebx
	pushl %edi
	leal -12(%ebp),%esi
	movl %ecx,%edi
	leal 8(%ebp),%edx
	movl 12(%edi),%ebx
	pushl 20(%edi)
	pushl %edx
	pushl %esi
	pushl %ebx
	movl 16(%edi),%eax
	call *%eax
	movw 20(%ebx),%ax
	cmpw $FFI_TYPE_INT,%ax
	jne .L218
	movl (%esi),%eax
	jmp .L219
	.p2align 4,,7
.L218:
	cmpw $FFI_TYPE_FLOAT,%ax
	jne .L220
	flds (%esi)
	jmp .L219
	.p2align 4,,7
.L220:
	cmpw $FFI_TYPE_DOUBLE,%ax
	jne .L222
	fldl (%esi)
	jmp .L219
	.p2align 4,,7
.L222:
	cmpw $FFI_TYPE_LONGDOUBLE,%ax
	jne .L224
	fldt (%esi)
	jmp .L219
	.p2align 4,,7
.L224:
	cmpw $FFI_TYPE_SINT64,%ax
	jne .L219
	movl 0(%esi),%eax; movl 4(%esi),%edx
.L219:
#if defined WIN86
	# deal with stdcall/cdecl, address of our ret
	# NB, 24 is offsetof(ffi_raw_closure, ret)
	leal 24(%edi),%ecx
#endif	
	leal -24(%ebp),%esp
	popl %edi	
	popl %ebx
	popl %esi
	leave
#if defined WIN86
	# deal with stdcall/cdecl, jump to the ret
	pushl %ecx
#endif	
	ret
	epilog(ffi_closure_raw_SYSV)

